require "util"

require "story"

script.on_init(function()
  global.story = story_init()
  game.players[1].force.disable_all_prototypes()
  game.map_settings.enemy_expansion.enabled = false
--  game.forces.enemy.evolution_factor = .3
  game.map_settings.enemy_evolution.enabled = false

  local recipe_list = game.players[1].force.recipes
  recipe_list["iron-plate"].enabled = true
  recipe_list["copper-plate"].enabled = true
  recipe_list["stone-brick"].enabled = true
  recipe_list["stone-wall"].enabled = true
  recipe_list["wood"].enabled = true
  recipe_list["stone-furnace"].enabled = true
  recipe_list["iron-stick"].enabled = true
  recipe_list["iron-axe"].enabled = true
  recipe_list["wooden-chest"].enabled = true
  recipe_list["iron-gear-wheel"].enabled = true
  recipe_list["burner-mining-drill"].enabled = true
  recipe_list["transport-belt"].enabled = true
  recipe_list["burner-inserter"].enabled = true
  recipe_list["offshore-pump"].enabled = true
  recipe_list["pipe"].enabled = true
  recipe_list["pipe-to-ground"].enabled = true
  recipe_list["boiler"].enabled = true
  recipe_list["steam-engine"].enabled = true
  recipe_list["electronic-circuit"].enabled = true
  recipe_list["copper-cable"].enabled = true
  recipe_list["pistol"].enabled = true
  recipe_list["submachine-gun"].enabled = true
  recipe_list["firearm-magazine"].enabled = true
  recipe_list["light-armor"].enabled = true
  recipe_list["electric-mining-drill"].enabled = true
  recipe_list["inserter"].enabled = true
  recipe_list["small-electric-pole"].enabled = true
  recipe_list["lab"].enabled = true
  recipe_list["science-pack-1"].enabled = true
  recipe_list["science-pack-2"].enabled = true
  recipe_list["iron-chest"].enabled = true
  recipe_list["repair-pack"].enabled = true
  
  recipe_list["science-pack-3"].enabled = false

  
  local technology_list = game.players[1].force.technologies
  for index, wert in pairs(technology_list) do
	wert.enabled = true
  end
  
  technology_list["logistics-3"].enabled = false
  technology_list["speed-module-2"].enabled = false
  technology_list["speed-module-3"].enabled = false
  technology_list["effectivity-module-2"].enabled = false
  technology_list["effectivity-module-3"].enabled = false
  technology_list["productivity-module-2"].enabled = false
  technology_list["productivity-module-3"].enabled = false
  technology_list["laser-turret-damage-3"].enabled = false
  technology_list["laser-turret-speed-3"].enabled = false
  technology_list["railway"].enabled = false
  technology_list["automated-rail-transportation"].enabled = false
  technology_list["rail-signals"].enabled = false
  
  technology_list["optics"].researched = true
  technology_list["logistics"].researched = true
  technology_list["automation"].researched = true
  technology_list["worker-robots-speed-1"].researched = true
  technology_list["worker-robots-storage-1"].researched = true
  technology_list["worker-robots-storage-2"].researched = true

	for _,ent in pairs(game.surfaces.nauvis.find_entities{{-500,-340},{-215,-100}}) do
		if ent.name=='diesel-locomotive' or ent.name=='gate' then
			ent.force=game.forces.neutral
		end
	end 
end)

story_table =
{
  {
	
		--Mission 1
	{
		action=
		function()
			game.show_message_dialog{text = {"prolog-1"}}
			game.show_message_dialog{text = {"prolog-2"}}
			game.show_message_dialog{text = {"prolog-3"}}
			game.show_message_dialog{text = {"prolog-4"}}
			game.show_message_dialog{text = {"prolog-5"}}
			game.show_message_dialog{text = {"prolog-6"}}
			game.show_message_dialog{text = {"prolog-7"}}
			game.show_message_dialog{text = {"prolog-8"}}
			game.show_message_dialog{text = {"prolog-9"}}
			game.show_message_dialog{text = {"prolog-10"}}
			game.show_message_dialog{text = {"prolog-11"}}
			game.show_message_dialog{text = {"prolog-12"}}
			game.show_message_dialog{text = {"prolog-13"}}
		end
	},
    {
      condition = story_elapsed_check(0),
      action =
      function()
        game.show_message_dialog{text = {"mission-1-1"}}
      end
    },
	{
      condition = story_elapsed_check(1),
      action =
      function()
        game.show_message_dialog{text = {"mission-1-2"}}
		game.players[1].set_goal_description({"mission-1-Ziel"})
      end
    },
	{
      condition = story_elapsed_check(1),
      action =
      function()
        game.show_message_dialog{text = {"mission-1-3"}}
      end
    },
	{
      condition =
      function()
	    local wrack = game.get_entity_by_tag("wrack")
        return wrack == game.players[1].opened or 
			not wrack.has_items_inside()
	  end
    },
	{
      condition = story_elapsed_check(2),
      action =
      function()
        game.show_message_dialog{text = {"computer-weg-1"}}
		game.show_message_dialog{text = {"computer-weg-2"}}
      end
    },
	--Mission 1 - GeschÃ¼tzturm
	{
      condition = 
	  function()
		return (game.players[1].position.x > -5) and (game.players[1].position.x < 10) and (game.players[1].position.y > 300) and (game.players[1].position.y < 350)
	  end,
      action =
      function()
		game.show_message_dialog{text = {"mission-1-4"}}
		game.show_message_dialog{text = {"mission-1-5"}}
      end
    },
	--Mission 1 - Festung
	{
      condition = 
	  function()
		return (game.players[1].position.x > 110) and (game.players[1].position.x < 120) and (game.players[1].position.y > 277) and (game.players[1].position.y < 327)
	  end,
      action =
      function()
		game.show_message_dialog{text = {"mission-1-6"}}
		game.show_message_dialog{text = {"mission-1-7"}}
        game.show_message_dialog{text = {"mission-1-8"}}
		game.players[1].set_goal_description({"mission-1-Ziel-2"})
      end
    },
	--Mission 1 - Sieg - Mission 2
    {
      condition = 
	  function()
		return (game.players[1].position.x > 155) and (game.players[1].position.x < 164) and (game.players[1].position.y > 295) and (game.players[1].position.y < 304)
	  end,
      action =
      function()
        game.show_message_dialog{text = {"mission-1-9"}}
		game.show_message_dialog{text = {"mission-1-10"}}
		game.show_message_dialog{text = {"mission-1-11"}}
		game.players[1].set_goal_description({"mission-2-Ziel"})
      end
    },
	--Mission 2 - Beisserinsel betreten
    {
      condition = 
	  function()
		return (game.players[1].position.x > 233) and (game.players[1].position.x < 250) and (game.players[1].position.y > 294) and (game.players[1].position.y < 320)
	  end,
      action =
      function()
	  game.show_message_dialog{text = {"mission-2-1"}}
	  game.show_message_dialog{text = {"mission-2-2"}}
      end
    },
	--Mission 2 - "MilitÃ¤r" erforschen
	{
	  condition = function() return game.players[1].force.technologies["military"].researched end,
	  action =
      function()
		game.show_message_dialog{text = {"mission-2-3"}}
		game.show_message_dialog{text = {"mission-2-4"}}
		game.players[1].set_goal_description({""})
      end
	},
	--Mission 3
	{
	  condition = story_elapsed_check(8),
	  action =
      function()
		game.players[1].set_goal_description({"mission-3-Ziel"})
		game.show_message_dialog{text = {"mission-3-1"}}
		game.show_message_dialog{text = {"mission-3-2"}}
		game.show_message_dialog{text = {"mission-3-3"}}
      end
	},
	{
	  condition = story_elapsed_check(10),
	  action =
      function()
		game.show_message_dialog{text = {"mission-3-4"}}
      end
	},
	--Mission 3 - Zweite Festung
	{
	  condition = 
	  function()
		return (game.players[1].position.x > 310) and (game.players[1].position.x < 364) and (game.players[1].position.y > 175) and (game.players[1].position.y < 198)
	  end,
	  action =
      function()
		game.show_message_dialog{text = {"mission-3-5"}}
      end
	},
	{
	  condition = story_elapsed_check(4),
	  action =
      function()
		game.show_message_dialog{text = {"mission-3-6"}}
      end
	},
	--Mission 3 - Vorgeschobene Festung
	{
	  condition = 
	  function()
		return (game.players[1].position.x > 385) and (game.players[1].position.x < 446) and (game.players[1].position.y > -57) and (game.players[1].position.y < -30)
	  end,
	  action =
      function()
		game.show_message_dialog{text = {"mission-3-7"}}
		game.show_message_dialog{text = {"mission-3-8"}}
		game.show_message_dialog{text = {"mission-3-9"}}
      end
	},
	--Mission 3 - Uneinnehmbare Festung - Mission 4
	{
	  condition = 
	  function()
		return (game.players[1].position.x > 402) and (game.players[1].position.x < 440) and (game.players[1].position.y > -155) and (game.players[1].position.y < -140)
	  end,
	  action =
      function()
	  game.players[1].set_goal_description({""})
		game.show_message_dialog{text = {"mission-3-10"}}
		game.show_message_dialog{text = {"mission-3-11"}}
		game.show_message_dialog{text = {"mission-3-12"}}
		game.players[1].set_goal_description({"mission-4-Ziel"})
      end
	},
	--Mission 4 - Leitung kappen
	{
	  condition = 
	  function()
		return game.get_entity_by_tag("leitung") == nil
	  end,
	  action =
      function()
		game.show_message_dialog{text = {"mission-4-1"}}
		game.show_message_dialog{text = {"mission-4-2"}}
		game.players[1].set_goal_description({"mission-4-Ziel-2"})
      end
	},
	--Mission 4 - Vorgeschobene Festung plÃ¼ndern
	{
	  condition = function() return game.players[1].get_item_count("fusion-reactor-equipment") > 0 end,
	  action =
      function()
		game.show_message_dialog{text = {"mission-4-3"}}
      end
	},
	--Mission 4 - Zweite Festung plÃ¼ndern
	{
	  condition = function() return game.players[1].get_item_count("energy-shield-mk2-equipment") > 0 end,
	  action =
      function()
		game.show_message_dialog{text = {"mission-4-4"}}
		game.show_message_dialog{text = {"mission-4-5"}}
		game.show_message_dialog{text = {"mission-4-6"}}
      end
	},
	--Mission 4 - Anderes Stadttor erreichen - Mission 5
	{
	  condition = 
	  function()
		return (game.players[1].position.x > -70) and (game.players[1].position.x < -20) and (game.players[1].position.y > -145) and (game.players[1].position.y < -130)
	  end,
	  action =
      function()
		game.show_message_dialog{text = {"mission-4-7"}}
		game.show_message_dialog{text = {"mission-4-8"}}
		game.show_message_dialog{text = {"mission-4-9"}}
		game.show_message_dialog{text = {"mission-4-10"}}
		game.players[1].set_goal_description({"mission-5-Ziel"})
      end
	},
	--Mission 5 - Ebene erreichen
	{
	  condition = 
	  function()
		return (game.players[1].position.x > -212) and (game.players[1].position.x < -195) and (game.players[1].position.y > -170) and (game.players[1].position.y < -120)
	  end,
	  action =
      function()
		game.show_message_dialog{text = {"mission-5-1"}}
		game.show_message_dialog{text = {"mission-5-2"}}
		game.show_message_dialog{text = {"mission-5-3"}}
		game.show_message_dialog{text = {"mission-5-4"}}
		game.show_message_dialog{text = {"mission-5-5"}}
      end
	},
	{
	  condition = story_elapsed_check(8),
	  action =
      function()
		game.show_message_dialog{text = {"mission-5-6"}}
		game.show_message_dialog{text = {"mission-5-7"}}
		game.show_message_dialog{text = {"mission-5-8"}}
		game.show_message_dialog{text = {"mission-5-9"}}
		game.show_message_dialog{text = {"mission-5-10"}}
		game.show_message_dialog{text = {"mission-5-11"}}
      end
	},
	--Mission 5 - Energiezentrale zerstÃ¶rt
	{
	  condition = 
	  function()
		return (game.players[1].position.x > -481) and (game.players[1].position.x < -454) and (game.players[1].position.y > -270) and (game.players[1].position.y < -257)
	  end,
	  action =
      function()
		game.players[1].set_goal_description({""})
		game.show_message_dialog{text = {"mission-5-12"}}
		game.show_message_dialog{text = {"mission-5-13"}}
      end
	},
	--Mission 6
	{
	  condition = story_elapsed_check(70),
	  action =
      function()
		game.players[1].set_goal_description({"mission-6-Ziel"})
		game.show_message_dialog{text = {"mission-6-1"}}
		game.show_message_dialog{text = {"mission-6-2"}}
      end
	},
	--Mission 6 - KillertÃ¼rme zerstÃ¶rt
	{
	  condition = 
	  function()
		return (game.players[1].position.x > -57) and (game.players[1].position.x < -36) and (game.players[1].position.y > -170) and (game.players[1].position.y < -162)
	  end,
	  action =
      function()
		game.show_message_dialog{text = {"mission-6-3"}}
		game.show_message_dialog{text = {"mission-6-4"}}
      end
	},
	--Mission 6 - Stadttore erreichen
	{
	  condition = 
	  function()
		return (game.players[1].position.x > -95) and (game.players[1].position.x < -63) and (game.players[1].position.y > -390) and (game.players[1].position.y < -374)
	  end,
	  action =
      function()
		game.players[1].set_goal_description({""})
		game.show_message_dialog{text = {"epilog-1"}}
		game.show_message_dialog{text = {"epilog-2"}}
		game.show_message_dialog{text = {"epilog-3"}}
		game.show_message_dialog{text = {"epilog-4"}}
		game.show_message_dialog{text = {"epilog-5"}}
		game.show_message_dialog{text = {"epilog-6"}}
		game.show_message_dialog{text = {"epilog-7"}}
		game.show_message_dialog{text = {"epilog-8"}}
		game.show_message_dialog{text = {"epilog-9"}}
		game.show_message_dialog{text = {"epilog-10"}}
		game.show_message_dialog{text = {"epilog-11"}}
		game.show_message_dialog{text = {"epilog-12"}}
		game.show_message_dialog{text = {"epilog-13"}}
		game.show_message_dialog{text = {"epilog-14"}}
      end
	},
	{
	  condition = story_elapsed_check(4),
	  action =
      function()
		game.show_message_dialog{text = {"ende-1"}}
		game.show_message_dialog{text = {"ende-2"}}
		game.show_message_dialog{text = {"ende-3"}}
      end
	}
  }
}

story_init_helpers(story_table)

script.on_event(defines.events, function(event)
  story_update(global.story, event, "")
end)
--this is needed as the recent update broke the mechanic of hiding into enemy trains
--script.on_event(defines.events.on_player.on_player_driving_changed_state, function(e)
script.on_event(defines.events.on_player_driving_changed_state, function(e)
	p=game.players[e.player_index]
	if p.vehicle and p.vehicle.name=='diesel-locomotive' then
		p.character.destructible=false
	else
		p.character.destructible=true
	end
end)
